# Non-deterministic walks

## Description
This project complements the article 'Combinatorics of nondeterministic walks' by Élie de Panafieu and Michael Wallner.

It contains a python file and a Maple worksheet. The python code builds automata corresponding to an N-steps family for either N-bridges or N-meanders. The file starts with an example to illustrate the code. The Maple worksheet inputs the transition matrix outputed by the python code and computes the series expansion of the generating functions of N-meanders and N-excursions. It uses this information to guess an algebraic equation satisfied by the generating function of N-meanders. 

## Installation
The python file relies on standard python3 instructions, and the 'json' package.
The Maple worksheet requires the Maple software.

## Authors and acknowledgment
Élie de Panafieu and Michael Wallner, with the support of
- Nokia Bell Labs,
- TU Wien,
- the Rise project RandNET, grant no.: H2020-EU.1.3.3,
- the Exzellenzstipendium of the Austrian Federal Ministry of Education, Science and Research and
Austrian Science Fund (FWF): P 34142 and J 4162,
- the Institut de recherche en informatique fondamentale of Université Paris-Cité (IRIF).

## License
Copyright 2024 Élie de Panafieu and Michael Wallner

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
